//------------------------------------------------------------------------------
// HEARTBEAT TOPMODEL
//------------------------------------------------------------------------------
// HEARTBEAT W[
// (1) HeartBeatH
//------------------------------------------------------------------------------
// Revision 00
// Level    01
//------------------------------------------------------------------------------
// File           : heartbeat.v
// Module         : HEARTBEAT
//------------------------------------------------------------------------------
// Rev.Level     Date    Cause Coded        Contents
// 00.01     2020/05/31     00              F.T)O.Aihara
//------------------------------------------------------------------------------
// 00.01     2020/05/31                     F.T)O.Aihara new

`timescale 1 ps / 1 ps

module HEARTBEAT	(
				input	wire							CLK,				// 
				input	wire							RESET_N,			// 
				output	wire							HEART_BEAT			// 
	);


//------------------------------------------------------------------------------
// wires
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// reges
//------------------------------------------------------------------------------
	reg		[31:0]		sr_heartbeat_cnt;		// 
	reg					sr_heartbeat;			// 


//------------------------------------------------------------------------------
// define
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Call Submodule
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Logic
//------------------------------------------------------------------------------
	assign		HEART_BEAT					=			sr_heartbeat;


//------------------------------------------------------------------------------
// 䕔
//------------------------------------------------------------------------------

	always@( posedge CLK or negedge RESET_N )begin
		if( RESET_N == 1'b0 )begin
			sr_heartbeat		<=		1'b0;
		end else if( sr_heartbeat_cnt[31:0] == 32'h012A_05F1 )begin
			sr_heartbeat		<=		~sr_heartbeat;
		end
	end

	always@( posedge CLK or negedge RESET_N )begin
		if( RESET_N == 1'b0 )begin
			sr_heartbeat_cnt[31:0]		<=		32'h0000_0000;
		end else if( sr_heartbeat_cnt[31:0] == 32'h012A_05F1 )begin
			sr_heartbeat_cnt[31:0]		<=		32'h0000_0000;
		end else begin
			sr_heartbeat_cnt[31:0]		<=		sr_heartbeat_cnt[31:0] + 32'h0000_0001;
		end
	end



endmodule

