library verilog;
use verilog.vl_types.all;
entity axi_fifo_rd is
    generic(
        DATA_WIDTH      : integer := 32;
        ADDR_WIDTH      : integer := 32;
        ID_WIDTH        : integer := 8;
        ARUSER_ENABLE   : integer := 0;
        ARUSER_WIDTH    : integer := 1;
        RUSER_ENABLE    : integer := 0;
        RUSER_WIDTH     : integer := 1;
        FIFO_DEPTH      : integer := 32;
        FIFO_DELAY      : integer := 0
    );
    port(
        clk             : in     vl_logic;
        rst             : in     vl_logic;
        s_axi_arid      : in     vl_logic_vector;
        s_axi_araddr    : in     vl_logic_vector;
        s_axi_arlen     : in     vl_logic_vector(7 downto 0);
        s_axi_arsize    : in     vl_logic_vector(2 downto 0);
        s_axi_arburst   : in     vl_logic_vector(1 downto 0);
        s_axi_arlock    : in     vl_logic;
        s_axi_arcache   : in     vl_logic_vector(3 downto 0);
        s_axi_arprot    : in     vl_logic_vector(2 downto 0);
        s_axi_arqos     : in     vl_logic_vector(3 downto 0);
        s_axi_arregion  : in     vl_logic_vector(3 downto 0);
        s_axi_aruser    : in     vl_logic_vector;
        s_axi_arvalid   : in     vl_logic;
        s_axi_arready   : out    vl_logic;
        s_axi_rid       : out    vl_logic_vector;
        s_axi_rdata     : out    vl_logic_vector;
        s_axi_rresp     : out    vl_logic_vector(1 downto 0);
        s_axi_rlast     : out    vl_logic;
        s_axi_ruser     : out    vl_logic_vector;
        s_axi_rvalid    : out    vl_logic;
        s_axi_rready    : in     vl_logic;
        m_axi_arid      : out    vl_logic_vector;
        m_axi_araddr    : out    vl_logic_vector;
        m_axi_arlen     : out    vl_logic_vector(7 downto 0);
        m_axi_arsize    : out    vl_logic_vector(2 downto 0);
        m_axi_arburst   : out    vl_logic_vector(1 downto 0);
        m_axi_arlock    : out    vl_logic;
        m_axi_arcache   : out    vl_logic_vector(3 downto 0);
        m_axi_arprot    : out    vl_logic_vector(2 downto 0);
        m_axi_arqos     : out    vl_logic_vector(3 downto 0);
        m_axi_arregion  : out    vl_logic_vector(3 downto 0);
        m_axi_aruser    : out    vl_logic_vector;
        m_axi_arvalid   : out    vl_logic;
        m_axi_arready   : in     vl_logic;
        m_axi_rid       : in     vl_logic_vector;
        m_axi_rdata     : in     vl_logic_vector;
        m_axi_rresp     : in     vl_logic_vector(1 downto 0);
        m_axi_rlast     : in     vl_logic;
        m_axi_ruser     : in     vl_logic_vector;
        m_axi_rvalid    : in     vl_logic;
        m_axi_rready    : out    vl_logic
    );
end axi_fifo_rd;
