library verilog;
use verilog.vl_types.all;
entity fsm is
    port(
        ACLK            : in     vl_logic;
        RSTN            : in     vl_logic;
        axi_s_arvalid   : in     vl_logic;
        axi_s_arready   : out    vl_logic;
        axi_s_araddr    : in     vl_logic_vector(39 downto 0);
        axi_s_arlen     : in     vl_logic_vector(7 downto 0);
        axi_s_arsize    : in     vl_logic_vector(2 downto 0);
        axi_s_arburst   : in     vl_logic_vector(1 downto 0);
        axi_s_arid      : in     vl_logic_vector(15 downto 0);
        axi_s_rvalid    : out    vl_logic;
        axi_s_rready    : in     vl_logic;
        axi_s_rlast     : out    vl_logic;
        axi_s_rdata     : out    vl_logic_vector(255 downto 0);
        axi_s_rresp     : out    vl_logic_vector(1 downto 0);
        axi_s_rid       : out    vl_logic_vector(15 downto 0);
        axi_s_awvalid   : in     vl_logic;
        axi_s_awready   : out    vl_logic;
        axi_s_awaddr    : in     vl_logic_vector(39 downto 0);
        axi_s_awlen     : in     vl_logic_vector(7 downto 0);
        axi_s_awsize    : in     vl_logic_vector(2 downto 0);
        axi_s_awburst   : in     vl_logic_vector(1 downto 0);
        axi_s_awid      : in     vl_logic_vector(15 downto 0);
        axi_s_wvalid    : in     vl_logic;
        axi_s_wready    : out    vl_logic;
        axi_s_wlast     : in     vl_logic;
        axi_s_wdata     : in     vl_logic_vector(255 downto 0);
        axi_s_wstrb     : in     vl_logic_vector(31 downto 0);
        axi_s_bvalid    : out    vl_logic;
        axi_s_bready    : in     vl_logic;
        axi_s_bresp     : out    vl_logic_vector(1 downto 0);
        axi_s_bid       : out    vl_logic_vector(15 downto 0);
        axi_m_arvalid   : out    vl_logic;
        axi_m_arready   : in     vl_logic;
        axi_m_araddr    : out    vl_logic_vector(39 downto 0);
        axi_m_arlen     : out    vl_logic_vector(7 downto 0);
        axi_m_arsize    : out    vl_logic_vector(2 downto 0);
        axi_m_arburst   : out    vl_logic_vector(1 downto 0);
        axi_m_arcache   : out    vl_logic_vector(3 downto 0);
        axi_m_arprot    : out    vl_logic_vector(2 downto 0);
        axi_m_arid      : out    vl_logic_vector(15 downto 0);
        axi_m_rvalid    : in     vl_logic;
        axi_m_rready    : out    vl_logic;
        axi_m_rlast     : in     vl_logic;
        axi_m_rdata     : in     vl_logic_vector(255 downto 0);
        axi_m_rresp     : in     vl_logic_vector(1 downto 0);
        axi_m_rid       : in     vl_logic_vector(15 downto 0);
        axi_m_awvalid   : out    vl_logic;
        axi_m_awready   : in     vl_logic;
        axi_m_awaddr    : out    vl_logic_vector(39 downto 0);
        axi_m_awlen     : out    vl_logic_vector(7 downto 0);
        axi_m_awsize    : out    vl_logic_vector(2 downto 0);
        axi_m_awburst   : out    vl_logic_vector(1 downto 0);
        axi_m_awcache   : out    vl_logic_vector(3 downto 0);
        axi_m_awprot    : out    vl_logic_vector(2 downto 0);
        axi_m_awid      : out    vl_logic_vector(15 downto 0);
        axi_m_wvalid    : out    vl_logic;
        axi_m_wready    : in     vl_logic;
        axi_m_wlast     : out    vl_logic;
        axi_m_wdata     : out    vl_logic_vector(255 downto 0);
        axi_m_wstrb     : out    vl_logic_vector(31 downto 0);
        axi_m_bvalid    : in     vl_logic;
        axi_m_bready    : out    vl_logic;
        axi_m_bresp     : in     vl_logic_vector(1 downto 0);
        axi_m_bid       : in     vl_logic_vector(15 downto 0);
        next_linkup     : in     vl_logic;
        ctrl_cmd        : out    vl_logic_vector(1 downto 0);
        ctrl_chip       : out    vl_logic_vector(3 downto 0);
        axi_busy        : out    vl_logic;
        unit1_exec      : in     vl_logic_vector(63 downto 0);
        unit1_fold      : in     vl_logic_vector(63 downto 0);
        unit1_stop      : in     vl_logic_vector(63 downto 0);
        unit2_exec      : in     vl_logic_vector(63 downto 0);
        unit2_fold      : in     vl_logic_vector(63 downto 0);
        unit2_stop      : in     vl_logic_vector(63 downto 0);
        axring_top_nemp : out    vl_logic;
        axring_top_ful  : in     vl_logic;
        axring_top      : out    vl_logic_vector(341 downto 0);
        axring_bot_nemp : in     vl_logic;
        axring_bot_ful  : out    vl_logic;
        axring_bot      : in     vl_logic_vector(341 downto 0)
    );
end fsm;
